D-POJ-3126 Prime Path

简介: Description The ministers of the cabinet were quite upset by the message from the Chief of...

Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0

BFS,将素数打表可以缩短运行时间。

#include<iostream>
#include<cstdio>
#include<cmath>
#include<queue>
#include<cstring>
using namespace std;

#define maxn 10005
bool vis[maxn];          //标记是否访问
bool IsPrime[maxn];      //标记素数

void Prime(){   //素数筛法
    IsPrime[0]=IsPrime[1]=false;IsPrime[2]=true;
    for(int i=3;i<maxn;i++){
        if(i%2)
            IsPrime[i]=true;
        else
            IsPrime[i]=false;
    }
    int m=sqrt(maxn*1.0);
    for(int i=3;i<m;i++){
        if(IsPrime[i]){
            for(int j=i;j<maxn;j+=i)
                IsPrime[j]=false;
        }
    }
}

struct Node{
    int p[4];
    int step;
};


void BFS(int a,int b){
    memset(vis, false, sizeof(vis));
    Node now,next;
    int x;
    queue<Node>Q;
    now.p[0]=a/1000;now.p[1]=a%1000/100;now.p[2]=a%100/10;now.p[3]=a%10;
    now.step=0;
    Q.push(now);
    while(!Q.empty()){
        now=Q.front();
        Q.pop();
        if(now.p[0]*1000+now.p[1]*100+now.p[2]*10+now.p[3]==b){
            printf("%d\n",now.step);
            return;
        }
        for(int i=0;i<=3;i++){
            for(int j=0;j<=9;j++){
                if(i==0&&j==0)
                    continue;
                if(now.p[i]==j)
                    continue;
                next.p[0]=now.p[0];
                next.p[1]=now.p[1];
                next.p[2]=now.p[2];
                next.p[3]=now.p[3];
                next.p[i]=j;
                x=next.p[0]*1000+next.p[1]*100+next.p[2]*10+next.p[3];
                if(!vis[x]&&IsPrime[x]){
                    next.step=now.step+1;
                    vis[x]=true;
                    Q.push(next);
                }
            }
        }
    }
    printf("Impossible\n");
}

int main(){
    Prime();
    int n,a,b;
    scanf("%d",&n);
    while(n--){
        scanf("%d%d",&a,&b);
        BFS(a,b);
    }
    return 0;
}

开始不管怎么运行都是输出Impossible,后来发现Prim函数没运行,蠢哭~

目录
相关文章
|
7月前
|
算法
HJ108 求最小公倍数
HJ108 求最小公倍数
55 0
|
机器学习/深度学习
poj 2155 Matrix (二维树状数组)
这是楼教主出的二维线段树或者是二维树状数组的题,题意很简单,就是有个n*n的矩阵,初始值都是0,然后给你两个操作,一个是给你左上角和右下角的坐标,把这个长方形的区间所有元素反取反(0变1 1变0),另一个是求某个具体坐标的值。 这里我用了二维的线树状数组,一维树状数组可以解决区间更新和点查询的问题,这里只需要加一维就可以了,代码比较好写,不过开始犯了很多低级的错误。
49 0
|
算法
POJ3061 Subsequence
POJ3061 Subsequence
UVa11679 - Sub-prime
UVa11679 - Sub-prime
63 0
|
算法
POJ 1844 Sum
POJ 1844 Sum
106 0
POJ 1844 Sum
Description Consider the natural numbers from 1 to N. By associating to each number a sign (+ or -) and calculating the value of this expression we obtain a sum S.
821 0
容斥 - HDU 4135 Co-prime
Co-prime  Problem's Link:  http://acm.hdu.edu.cn/showproblem.php?pid=4135 推荐: 容斥原理 Mean:  给你一个区间[l,r]和一个数n,求[l,r]中有多少个数与n互素。
908 0